function [b, pb] = learn_marker_metaprior (f, pf, b, pb, w, b0, b1, e)

fprintf('BOF::learn_marker_metaprior\n');

[ntasks, nfeats] = size(w);

u = abs(w)';

alpha = 0.3;
beta = 0.8;

e_seq = e;
e_func = e;
e_pair = e;

nmods = size( pf{1}{1},2 );

grad = zeros( length(b),1 );

for iter = 1 : 10

   a = calculate_marker_relevance ( f, b0, b1, b, pf, pb );

   preobj = e * b' * b + e_pair * pb'*pb + sum( sum( u .* a ) );
   
   %e_seq * b(1:8)'*b(1:8) + e_func * b(9:end)'*b(9:end) + e_pair * pb'*pb...
   grad(1:8) = 2 * e_seq * b(1:8);
   grad(9:end) = 2 * e_func * b(9:end);
   pgrad = 2 * e_pair * pb;

   for n = 1 : nfeats
      rel0 = f{n}*b;
      for m = 1 : nmods %% insert an if statement
         if( u(n,m) > 0 )
            rel = rel0;
	    %while(0),
	    for k = 1 : length(pf)
	       rel = rel + pf{k}{n}(:,m) * pb(k);
	    end
	    %end
	    z2 = sigmoid( rel );
	    z1 = sigmoid( sum( 2*z2-1 ) );

	    const = u(n,m) * ( b1 - b0 ) * 2 * z1 * (1-z1);
	    const2 = z2 .* ( 1 - z2 );
	    grad = grad + const * f{n}' * const2;
	    %while(0),
	    for k = 1 : length(pgrad)
   	       pgrad(k) = pgrad(k) + const * pf{k}{n}(:,m)' * const2;
	    end
	    %end
	 end
      end
   end

   grad2 = grad'* grad + pgrad'*pgrad;
   
   t = 0.0001;
   for biter = 1 : 100
      new_b = b - t * grad;
      new_pb = pb - t * pgrad;

      if( length( find( new_b<0 ) )==0 & length( find( new_pb<0 ) )==0 )
         new_a = calculate_marker_relevance ( f, b0, b1, new_b, pf, new_pb );
	 
	 postobj = e_seq * new_b(1:8)' * new_b(1:8) ...
	    + e_func * new_b(9:end)' * new_b(9:end) ...
	    + e_pair * new_pb'*new_pb + sum( sum( u .* new_a ) );

         %fprintf('biter:%g t:%g %g %g %g\n',biter,t,preobj,postobj,preobj-alpha*t*grad2);
	 if( postobj < preobj - alpha * t * grad2 )
	    break;
         else
            t = t * beta;
         end
      else
         t = t * beta;
      end
   end
   if( postobj < preobj )
      b = new_b;	pb = new_pb;
   end
%b',pb
%   if( mod(iter,10)==0 )
   fprintf('iter = %g\t%g\t%g\tdel = %g\n',iter, preobj, postobj, preobj-postobj);
%   end
   if( abs( preobj-postobj )<0.01 )
      break;
   end
end

fprintf('EOF::learn_marker_metaprior\n\n');

