function [b, pb] = learn_regul_metaprior (f, pf, b, pb, w, b0, b1, e)

fprintf('BOF::learn_marker_metaprior\n');

[ntasks, nfeats] = size(w);

u = abs(w)';

%for n = 1 : nfeats
%   u{n} = zeros( nsubfeats(n),1 );
%end
%for k = 1 : ntasks
%   for n = 1 : nfeats
%      u{n} = u{n} + c{k}{n} * abs( w(k,n) );
%   end
%end

alpha = 0.3;
beta = 0.8;

e_seq = e;
e_func = e;%100 * e;
e_pair = e;%/10;

nmods = size( pf{1},2 );

grad = zeros( length(b),1 );

for iter = 1 : 100

   a = calculate_regul_relevance ( f, b0, b1, b, pf, pb );

   if( length(b)>8 )
      preobj = e * b(1:8)'*b(1:8) + e_func * b(9:end)'*b(9:end) ...
         + e_pair * pb'*pb + sum( sum( u .* a ) );
      grad(1:8) = 2 * e * b(1:8);
      grad(9:end) = 2 * e_func * b(9:end);
   else
      preobj = e * b'*b + e_pair * pb'*pb + sum( sum( u .* a ) );
      grad = 2 * e * b;
   end
   pgrad = 2 * e_pair * pb;

   rel0 = f*b;

   for m = 1 : nmods;
      rel = rel0;
      %while(0),
      for k = 1 : length(pf)
         rel = rel + pf{k}(:,m) * pb(k);
      end
      %end
      z = sigmoid( rel );
      grad = grad + (b1-b0) * ( ( z .* (1-z).*u(:,m) )' * f )';
      %while(0),
      for k = 1 : length(pf)
         pgrad(k) = pgrad(k) + (b1-b0) * ( ( z .* (1-z) .* u(:,m) )'*pf{k}(:,m) )';
      end
      %end
   end

   grad2 = grad'* grad + pgrad'*pgrad;
   
   t = 1;
   
   for biter = 1 : 100
   
      new_b = b - t * grad;
      new_pb = pb - t * pgrad;

%      if( length( find( new_b<0 ) )==0 & length( find( new_pb<0 ) )==0 )
         new_a = calculate_regul_relevance ( f, b0, b1, new_b, pf, new_pb );
	 if( length(b) > 8 )
	    postobj = e * new_b(1:8)' * new_b(1:8) ...
	    + e_func * new_b(9:end)' * new_b(9:end) ...
	    + e_pair * new_pb'*new_pb + sum( sum( u .* new_a ) );
	    %fprintf('biter:%g t:%g %g %g %g\n',biter,t,preobj, postobj, preobj - alpha * t * grad2);
	 else
	    postobj = e * new_b' * new_b ...
	    + e_pair * new_pb'*new_pb + sum( sum( u .* new_a ) );
	 end

         if( postobj < preobj - alpha * t * grad2 )
	    break;
	 else
            t = t * beta;
         end
%      else
%         t = t * beta;
%      end
   end
   if( postobj<preobj )
      b = new_b;
      pb = new_pb;
   end
%pb'
   fprintf('iter = %g\t%g\t%g\tdel = %g\n',iter, preobj, postobj, preobj-postobj);

   if( abs( preobj-postobj )<0.001 )
      break;
   end
end

fprintf('EOF::learn_marker_metaprior\n\n');
