function [mw, rw] = learn_weights (x, y, cent, assign, ma, ra, d)

fprintf('BOF::learn_weights\n');

[nmarkers] = size(x,1);
[ngenes] = size(y,1);
[ncls, nsamples] = size(cent);

feat = [y; x];featT = feat';

nfeats = nmarkers + ngenes;

l2 = d*ones(nfeats,1);

w = zeros(ncls, nfeats);

for k = 1 : ncls

   if( mod(k,20)==0 )
      fprintf('k = %g / ncls = %g\n',k,ncls);
   end
   
   l1 = [ra(:,k); ma(:,k)];

   vindx = setdiff( 1:nfeats, find( assign==k ) );

   [w0, w(k,vindx)] = least_squares_l1_penalty_one_feat ...
      (feat(vindx,:), featT(:,vindx), cent(k,:), l1(vindx), l2(vindx));

end
rw = w(:,1:ngenes);	mw = w(:,ngenes+1:end);

fprintf('EOF::learn_weights\n\n');

