function [w0, w] = least_squares_l1_penalty_one_feat ( x, xT, y, c, d, w )
%function [w0, w] = least_squares_l1_penalty ( x, y, c )
%[nfeatures, nsamples] = size(x);


[nfeatures, nsamples] = size(x);

%fprintf('%g %g\n',nfeatures,nsamples);

%xT = x';

w0 = mean(y);
y = y - w0;


a = sparse(1,nfeatures);
if(~exist('w'))
   w = zeros(1,nfeatures);
else
   a( find( w~=0 ) ) = 1;
end
if(~exist('d'))
   d = zeros(nfeatures,1);
end
if( length(c)==1 )
   c = c * ones(nfeatures,1);
end
if( length(d)==1 )
   d = d * ones(nfeatures,1);
end


alphaa = 0.3;
betaa = 0.8;

maxiters = 300;

for iter = 1 : maxiters
%tic;
   z = w * x - y;

   preobj = sum( sum( z.^2 ) ) + abs(w)*c + (w.*w) * d;

   if( iter==1 )
      ppreobj = preobj;
   end
%toc;
%tic;
   grad = 2 * z * xT + 2 * d' .* w;

   abs_grad = abs(grad);
   abs_grad( find( a==1 ) ) = 0;

   [mx, mxindx] = max(abs_grad-c');
%mx
%toc;
%tic;
   if( mx>0 )
      a(mxindx) = 1;w(mxindx) = 1.0e-5*sign(grad(mxindx));
   end

   active = find( a==1 );
   
   grad(active) = grad(active) + c(active)' .* sign(w(active));
%   step = 2 * grad(active) * xxT(active,active);

   grad2 = sum( sum( grad(active).^2 ) );
%   grad2 = grad(active)*step';
%toc;
   t = 1;
%tic;
   for biter = 1 : 300
   
%      neww = w(active) - t * step;
      neww = w(active) - t * grad(active);

      newz = neww * x(active,:) - y;

      postobj = sum( sum( newz.^2 ) ) + abs(neww)*c(active) + (neww.*neww)*d(active);

%fprintf('preobj:%g	postobj:%g\n',preobj,postobj);
%pause;

      if( postobj < preobj - alphaa * t * grad2 )
         break;
      else
         t = betaa * t;
      end

   end
%toc;
%fpritnf('\n');
   if( preobj > postobj )
      w(active) = neww;
   end
%fprintf('iter:%g	a:%g	preobj:%g	obj:%g	del:%g\n',...
%   iter,length(find(a==1)),preobj,postobj,abs(preobj-postobj));

   if( abs(preobj-postobj) < 0.001 )
      break;
   end
end
%abs(preobj-postobj)
%postobj
%fprintf('iter:%g	a:%g	ppreobj:%g	preobj:%g	obj:%g	del:%g\n',...
%   iter,length(find(a==1)),ppreobj,preobj,postobj,abs(ppreobj-postobj));
