function [params] = lirnet (ydata, assign, maxiters, nreguls, params)

ncls = max(assign);

x = ydata.g.nrm;
y = ydata.e.nrm;

mf = ydata.mf.nrm;
for k = 1 : length(ydata.mf_pair)
   mf_pair{k} = ydata.mf_pair{k}.nrm;
end

rf = ydata.rf.nrm;
for k = 1 : length(ydata.rf_pair)
   rf_pair{k} = ydata.rf_pair{k}.nrm;
end

[nmarkers, nsamples] = size(x);
[ngenes, nsamples] = size(y);

num_mfeats = size( mf{1}, 2 );
num_rfeats = size( rf, 2 );

cent = zeros(ncls,nsamples);%calculate_centroids(y,assign);
for n = 1 : ncls
   cent(n,:) = mean( y( find(assign==n),: ),1 );
end

obj = 0;

mb0 = params.mb0;mb1 = params.mb1;rb0 = params.rb0;rb1 = params.rb1;
d = params.d;	e = params.e;

mw = zeros(ncls, nmarkers);	rw = zeros(ncls, ngenes);
mb = 0*ones(num_mfeats,1);	rb = zeros(num_rfeats,1);

mb_pair = 0*ones( length(mf_pair),1 );rb_pair = zeros( length(rf_pair),1 );

if( exist( 'params' ) )
   mb = params.mb;	mb_pair = params.mb_pair;
   rb = params.rb;	rb_pair = params.rb_pair;
end
%end

for iter = 1 : maxiters

   fprintf('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n');
   fprintf('   ITER = %g/ %g\n', iter, maxiters);
   fprintf('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n');

   [ma] = calculate_marker_relevance ( mf, mb0, mb1, mb, mf_pair, mb_pair );
   [ra] = calculate_regul_relevance ( rf, rb0, rb1, rb, rf_pair, rb_pair );

   ra( nreguls, : ) = 1.0e10;
   fprintf('learn weights...\n');
   [mw, rw] = learn_weights (x, y, cent, assign, ma, ra, d);

   if( iter == 1 )
      params.mw0 = mw;	params.rw0 = rw;
   end
%   sparse( sum( rw(:,params.nreguls) ) )
   if( maxiters>1 )

      if( iter==1 )
         mb = 0.1*ones(num_mfeats,1);
	 mb_pair = 0.1*ones(length(mf_pair),1)
         %rb = 0.1*ones(num_rfeats,1);
	 %rb_pair = 0.1*ones(length(rf_pair),1)
      end
      [mb,mb_pair] = learn_marker_metaprior(mf,mf_pair,mb,mb_pair,mw,mb0,mb1,e);
      [rb,rb_pair] = learn_regul_metaprior(rf,rf_pair,rb,rb_pair,rw,rb0,rb1,e);
   end

   preobj = obj;

   [ma] = calculate_marker_relevance ( mf, mb0, mb1, mb, mf_pair, mb_pair );
   [ra] = calculate_regul_relevance ( rf, rb0, rb1, rb, rf_pair, rb_pair );
   [obj] = calculate_objective ( cent, x, y, mw, rw, ma, ra, d, e );

   fprintf('\niter = %g\tobj = %g\tdel = %g\n\n',iter, obj, preobj-obj);
end

params.ma = ma;			params.ra = ra;
params.mb = mb;			params.rb = rb;
params.mw = mw;			params.rw = rw;
params.mb0 = mb0;		params.mb1 = mb1;
params.rb0 = rb0;		params.rb1 = rb1;

params.mb_pair = mb_pair;	params.rb_pair = rb_pair;

